var last_song = '';
var lrc_lines = [];
var current_time;
var last_line = '';
var last_sync_time = 0; 
var lastTitle = '';
//window.retry = false;
var current_song = {};

widget.onshow = init;
widget.onhide = unactive;

function init()
{
	//window.timer1 = setInterval(updateInfo,2000);
	window.timer2 = setInterval(updatePosition,500);
	window.timer3 = setInterval(syncPosition,1000);
}

function unactive()
{
	try
	{
		clearInterval(window.timer1);
	}catch(e){ }
	try
	{
		clearInterval(window.timer2);
	}catch(e){ }
	try
	{
		clearInterval(window.timer3);
	}catch(e){ }
}

function syncPosition()
{
	if (iTunes.update()) //if running
    {
        var pos = iTunes.playerPosition();
        var t = pos*1000;
        current_time = t;
        last_sync_time = t;
        
        if (lastTitle != iTunes.currentTitle())
        {
            lastTitle = iTunes.currentTitle();
            updateInfo();
        }
    }
    else
    {
        showNotRunning();
    }
}


function showNotRunning()
{
	$('#global-info').html('iTunes is not running').show();
	$('#lines').html('');
}

function debug(msg)
{
	console.log(msg);
}

function updatePosition()
{
	current_time+=200;
	ct = current_time + 500;
	var last_time = 0;
    var found_current = false;
	var lrcs = $('.lrc');
	for(i=1;i<lrcs.length;i++)
	{
		if (ct >= lrcs.eq(i-1).data('time') && ct < lrcs.eq(i).data('time'))
		{
			var cdom = lrcs.eq(i-1);
			var current = $('.current');
			if (current.data('top') >= cdom.data('top') && current.data('top') - cdom.data('top') < cdom.height()+10) return;
			if (last_line != cdom.attr('id') )
			{
				current.removeClass('current');
				cdom.addClass('current');
				last_line = lrcs.eq(i-1).attr('id');
                found_current = true;
				updateScroll();
				return;
			}
		}
	}
}

function updateScroll()
{
	if ($('.current').length == 0 || $('.current').html().length <= 0)
    {
        return;
    }
    
	$('.current').css('opacity',1);
	var prev = $('.current').prev('.lrc');
	var next = $('.current').next('.lrc');
	for(i=0.9;i>=-2;i-=0.3)
	{
		opacity = i;
		if (opacity<=0) opacity = 0;
		if (prev.length > 0)
		{
			prev.css('opacity',opacity-0.3);
			prev = prev.prev('.lrc');
		}
		if (next.length > 0)
		{
			next.css('opacity',opacity);
			next = next.next('.lrc');
		}
	}
	
	var top = $('.current').data('top');
	if (!top || top <= 0 ) return;
	var margintop = 60-parseInt($('.current').data('top'));
	if (margintop >0 ) margintop = 0;
	$('#lines').css('margin-top',margintop);
}

function updateInfo()
{
	if (iTunes.update()) //if running
    {
        $('#global-info').html('Loading.');
        widget.system("/usr/bin/osascript info.scpt",function(str)
        {
            updateInfoDo(str.outputString);
        });
    }
}

function updateInfoDo(info)
{
	var song = {};
	if (info)
	{
		info = info.split('|');
		song.artist = info[0];
		song.album = info[1];
		song.name = info[2];
		song.location = info[3];
	}
	else return;
	if (song.name+song.artist == last_song && !window.retry) return;
	last_song = song.name + song.artist;
	
    if (window.retry)
        $('#global-info').html('Searching for another lyric...');
    else
        $('#global-info').html('Loading..');
    
    current_song = song;
	current_time = 0;
	song.location = '/'+song.location.replace(/^[^\:]+\:/,'').replace(/\:/g,'/').replace(/\s+$/g,'');
	song.lrc = song.location.replace(/\.[a-z0-9]{2,4}$/,'.lrc');
	var para = song.lrc+':'+song.name.replace(':',' ')+':'+song.artist.replace(':',' ');
	if (window.retry) para+=':retry';
	window.retry = false;
	//$('#global-info').html('Searching...');
    
	para = encodeURIComponent(para);
	para = para.replace(/\(/g,'%28').replace(/\)/g,'%29').replace(/\,/g,'%2C');
    para = para.replace(new RegExp("\'",'g'),'%27');
    para = para.replace(new RegExp('\-','g'),'%forwardslash');
    
    lrc_lines = [];
	widget.system("/usr/bin/php getlrc.php "+para,function(o)
	{
		loadLrcDo(o.outputString);
	});
}

function loadLrcDo(lines)
{
	var dom = $('#global-info');
	if (lines == 'no network')
	{
		dom.html('Network error!');
	}
	else if (lines == 'notfound')
	{
		dom.html('No lyric available!');
	}
	else
	{
		dom.html('');
		$('#lines').html('<div class="lrc ti" id="lrc_1"><span>'+current_song.name+'</span></div>'
            +'<div class="lrc ar" id="lrc_1"><span>'+current_song.artist+'</span></div>'
            +lines);
        $('#lines').css('margin-top','30px');
		var top = 0;
		$('.lrc').each(function()
		{
			$(this).data('top',top);
            $(this).data('time',parseInt($(this).attr('id').replace('lrc_','')));
			top+= $(this).height();
		});
	}
}

function doretry()
{
	if (window.iTunes)
	{
		if (iTunes.update()) //if running
		{
			window.retry = true;
			$('#lines').html('');
			updateInfo();
		}
	}
}